<?php 

if($peticionAjax){
	require_once "../modelos/cosechadorModelo.php";
}else{
	require_once "./modelos/cosechadorModelo.php";
}

class cosechadorControlador extends cosechadorModelo{
	/*--------- controlador registrar cosecha  -------*/
	public function registrar_cosecha_controlador(){
		// Captura los datos JSON enviados desde JavaScript
		$jsonData =$_POST['cosecha_dato_reg'];

		// Decodifica el JSON en un array asociativo
		$data = json_decode($jsonData, true);  // Asegúrate de agregar el parámetro true para obtener un array asociativo

		// Verifica si la decodificación fue exitosa
		if (isset($data) && is_array($data)) {
			// cmapoos que dbeo de contener la estrcutura del excel
			$campos_obligatorios = [
	            "FECHA", "HORA", "LOTE", "TURNO", "VARIEDAD", "HORARIO",
	            "DNI_JEFE_GRUPO", "DATO_JEFE_GRUPO", "DNI_JEFE_CUADRILLA",
	            "DATO_JEFE_CUADRILLA", "DNI_COSECHADOR", "DATO_COSECHADOR",
	            "KG", "KG_DESCARTE"
	        ];
			// Itera sobre los datos recibidos
	        foreach ($data as $index => $fila) {
	            // Verifica si todos los campos necesarios están presentes
	            $campos_faltantes = array_diff($campos_obligatorios, array_keys($fila));
	            
	            // Si faltan campos, se detiene el proceso y se devuelve un mensaje de error
	            if (!empty($campos_faltantes)) {
	                $alerta = [
	                    "Alerta" => "simple",
	                    "Titulo" => "Error en la estructura",
	                    "Texto" => "El archivo Excel no tiene la estructura requerida. Fila " . ($index + 1) . " carece de los siguientes campos: " . implode(", ", $campos_faltantes),
	                    "Tipo" => "error"
	                ];

	                return json_encode($alerta);
	                exit();  // Detiene el proceso completamente
	            }
	        }

			$errores = 0;  // Contador de errores
    		$exitos = 0;   // Contador de inserciones exitosas

		    // Itera sobre los datos recibidos
		    foreach ($data as $fila) {
		        // Asigna cada campo a una variable
		        $fecha = $fila["FECHA"];
		        $hora = $fila["HORA"];
		        $lote = $fila["LOTE"];
		        $turno = $fila["TURNO"];
		        $variedad = $fila["VARIEDAD"];
		        $horario = $fila["HORARIO"];
		        $dni_jefe_grupo = $fila["DNI_JEFE_GRUPO"];
		        $dato_jefe_grupo = $fila["DATO_JEFE_GRUPO"];
		        $dni_jefe_cuadrilla = $fila["DNI_JEFE_CUADRILLA"];
		        $dato_jefe_cuadrilla = $fila["DATO_JEFE_CUADRILLA"];
		        $dni_cosechador = $fila["DNI_COSECHADOR"];
		        $dato_cosechador = $fila["DATO_COSECHADOR"];
		        $kg_exportable = $fila["KG"];
		        $kg_descarte = $fila["KG_DESCARTE"];

		        // Construye el array por cada fila de datos
		        $datos_agregar_general = [
		            "Fecha" => $fecha,
		            "Hora" => $hora,
		            "Lote" => $lote,
		            "Turno" => $turno,
		            "Variedad" => $variedad,
		            "Horario" => $horario,
		            "DNI_Jefe_Grupo" => $dni_jefe_grupo,
		            "Dato_Jefe_Grupo" => $dato_jefe_grupo,
		            "DNI_Jefe_Cuadrilla" => $dni_jefe_cuadrilla,
		            "Dato_Jefe_Cuadrilla" => $dato_jefe_cuadrilla,
		            "DNI_Cosechador" => $dni_cosechador,
		            "Dato_Cosechador" => $dato_cosechador,
		            "KG_Exportable" => $kg_exportable,
		            "KG_Descarte" => $kg_descarte
		        ];

		        // Llama a la función o clase que registra la cosecha en la base de datos
		        $agregar_general=cosechadorModelo::registrar_cosecha_modelo($datos_agregar_general);

		        // Verifica si la inserción fue exitosa
		        if ($agregar_general->rowCount() == 1) {
		            $exitos++;  // Incrementa el contador de registros exitosos
		        } else {
		            $errores++;  // Incrementa el contador de errores
		        }

		    }

		    // Prepara la respuesta dependiendo del resultado
		    if ($errores == 0) {
		        $alerta = [
		            "Alerta" => "simple",
		            "Titulo" => "Éxito",
		            "Texto" => "Todos los registros fueron importados con éxito",
		            "Tipo" => "success"
		        ];
		    } elseif ($exitos > 0 && $errores > 0) {
		        $alerta = [
		            "Alerta" => "simple",
		            "Titulo" => "Importación Parcial",
		            "Texto" => "$exitos registros fueron importados, pero $errores fallaron.",
		            "Tipo" => "warning"
		        ];
		    } else {
		        $alerta = [
		            "Alerta" => "simple",
		            "Titulo" => "Error importar el excel",
		            "Texto" => "los datos del Excel probablemente ya esten cargado en la BASE DE DATOS.",
		            "Tipo" => "error"
		        ];
		    }

		    // Responde en formato JSON
		    return json_encode($alerta);
		    exit();
		} else {
		    // En caso de error de decodificación, mostrar mensaje de error
		    $alerta=[
				"Alerta"=>"simple",
				"Titulo"=>"Error al decodificar JSON",
				"Texto"=>"No se recibieron datos válidos",
				"Tipo"=>"error"
			];

			return json_encode($alerta);
			exit();
		}
	}

	/*--------- controlador listar kg coschador  -------*/
	public function listar_kg_cosechador_controlador(){
		$cosechador_dni = $_POST['cosechador_dni_list'];
		$cosechador_fecha = $_POST['cosechador_fecha_list'];

		/* ===== Comprobar los campos vacios ==== */
		if($cosechador_dni == "" || $cosechador_fecha == ""){
			$alerta=[
				"Alerta"=>"simple",
				"Titulo"=>"Ocurrio un error inesperado",
				"Texto"=>"Los CAMPOS REQUERIDOS estan vacios.",
				"Tipo"=>"error"
			];

			echo json_encode($alerta);
			exit();
		}


		//  enviqamos  los datos hacia  la BD.	
		$datos_listar_kg_cosechador = [
			"Cosechador_dni"=>$cosechador_dni,
			"cosechador_fecha"=>$cosechador_fecha
		];
		$listar_kg_cosechador=cosechadorModelo::listar_kg_cosechador_modelo($datos_listar_kg_cosechador);
		if ($listar_kg_cosechador) {
			if(is_array($listar_kg_cosechador) && count($listar_kg_cosechador) > 0){
				return json_encode($listar_kg_cosechador);
			}else{
				$alerta=[
					"Alerta"=>"simple",
					"Titulo"=>"No se ecnontraron datos, Error 404",
					"Texto"=>"El retorno no contiene datos validos",
					"Tipo"=>"error"
				];

				echo json_encode($alerta);
				exit();	
			}
		}else{
			$alerta=[
				"Alerta"=>"simple",
				"Titulo"=>"Ocurrio un error inesperado, Error 500",
				"Texto"=>"Ocurrio un error no se listraron los datos del cosechador",
				"Tipo"=>"error"
			];

			echo json_encode($alerta);
			exit();		
		}
	}

	//  funcion para consurmir una API
	function API_Cosecha(){
		$fecha = $_POST['api_fecha'];

		$url = "https://api.agromas.pe:9443/agromas/web/general/cosecha_qr?fecha=".$fecha;
		$apiKey = "4E334466CACDE79DDD3358EA8692F8AC7259499BFE987D72C7BFBA94D96151DD"; // Clave del API

		$options = [
		    "http" => [
		        "header" => "X-Agromas-Apikey: " . $apiKey . "\r\n",
		        "method" => "GET"
		    ]
		];

		$context = stream_context_create($options);

		// Realizar la solicitud
		$response = file_get_contents($url, false, $context);

		// Manejar la respuesta
		if ($response === FALSE) {
		    $alerta=[
				"Alerta"=>"simple",
				"Titulo"=>"Error al CONSUMIR EL API",
				"Texto"=>"No se  logro hacer la conexio hacia la abse de datos",
				"Tipo"=>"error"
			];

			return json_encode($alerta);
			exit();
		} else {
		    $data = json_decode($response, true); // Convertimos la respuesta a JSON
		    return $response; // Mostramos los datos
		}
	}
}