<style>
    #canvas-container {
    position: relative;
    width: 100%;
    max-width: 400px; /* Ajusta el máximo ancho según sea necesario */
    height: auto;
    padding-top: 100%; /* Relaciona la altura con el ancho para mantener la proporción 1:1 */
    background-color: #000; /* Fondo negro para mejor contraste si la cámara no está activa */
}

#video {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    object-fit: cover;
}

#overlay {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    pointer-events: none;
}

.qr-border {
    border: 2px solid rgba(0, 255, 0, 0.8); /* Color verde con algo de transparencia */
    border-radius: 8px; /* Esquinas más redondeadas */
    box-shadow: 0 0 15px rgba(0, 255, 0, 0.6); /* Sombra verde más suave */
    pointer-events: none; /* Asegura que el borde no interfiera con eventos */
}

/* Responsividad adicional */
@media (max-width: 600px) {
    .qr-border {
        border-width: 1px; /* Reduce el grosor del borde en pantallas pequeñas */
        box-shadow: 0 0 8px rgba(0, 255, 0, 0.5); /* Ajusta la sombra para pantallas pequeñas */
    }
}

/* Demo Styles */

input {
    font-size: 1.5rem;
    padding: .5rem;
    border-radius: 5px;
    border: 1px solid #ccc;
    margin: 2rem 0;
    direction: ltr;
    text-align: center;
}

.use {
    width: 100%;
    max-width: 600px;
    margin: 0 auto;
}

pre {
    background: #333;
    color: #eee;
    padding: 1rem;
    border-radius: 5px;
}

a {
    color: darkslateblue;
    text-decoration: none;
}
</style>
<!--  listado de registro - inicio -->
<!-- INPUT para  alamcenar y gaurdar el id de usuario -->

<input type="hidden" name="trabajador_id_dato" id="trabajador_id_dato">
<div id="frm_registro"> 
    <div class="card card-style">
        <div class="position-relative pb-5">
            <div class="position-absolute top-0 start-0">
                <button type="button" class="icon icon-l p-3" id="btn_mostrar_camara" name="btn_mostrar_camara"  data-bs-toggle="modal" data-bs-target="#exampleModal"><i class="fa-solid fa-camera rounded-m bg-green-dark d-block mb-1"></i></button>
            </div>
            <div class="position-absolute top-0 start-50 translate-middle-x" style="margin-right: 30px;">
                <input type="date" name="fecha_actual_sistema" id="fecha_actual_sistema">
            </div>
            <div class="position-absolute top-0 end-0">
                <button type="button" onclick="consumir_API();" class="icon icon-l p-3" id="btn_consumir_api" name="btn_consumir_api" ><i class="fa-solid fa-rotate rounded-m bg-blue-dark d-block mb-1"></i></button>
            </div>
        </div>
            
        <div class="content pt-5" style="margin: 2px !important;">

            <!--<input type="text" id="timepicker" placeholder="Pick a time..." />-->

            <div class=" m-0">
                <div class="row" id="frm_header_cosecha">
                    
                </div>
                <table class="table table-borderless text-center rounded-sm shadow-l" >
                    <thead>
                        <tr class="bg-red-light">
                            <th scope="col" class="color-theme py-3 font-14">Hora</th>
                            <th scope="col" class="color-theme py-3 font-14">Variedad</th>
                            <th scope="col" class="color-theme py-3 font-14">Turno</th>
                            <th scope="col" class="color-theme py-3 font-14">Kg</th>
                            <th scope="col" class="color-theme py-3 font-14">Descarte</th>
                        </tr>
                    </thead>
                    <tbody id="list_kg_frm">
                        
                    </tbody>
                </table>
                <div class="row m-1 bg-mint-light" id="frm_footer_cosecha">
                    
                </div>
            </div>
        </div>
    </div>
</div>                         
<!--  listado de registro  - fin -->


<!-- Modal para  uso de camara -  inicio -->
<div class="modal fade" id="exampleModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
  <div class="modal-dialog modal-fullscreen">
    <div class="modal-content ">
      <div class="modal-header bg-green-light">
        <h1 class="modal-title fs-5" id="exampleModalLabel">Asistencia Personal</h1>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
      </div>
      <div class="modal-body">
        <div class="input-style has-borders input-style-always-active no-icon mb-4">
            <label for="camera-selec" class="color-highlight font-500">Camara</label>
            <select id="camera-select">
                <option value="">Selecciona una cámara</option>
            </select>
            <span><i class="fa fa-chevron-down"></i></span>
            <i class="fa fa-check disabled valid color-green-dark"></i>
            <i class="fa fa-check disabled invalid color-red-dark"></i>
            <em></em>
        </div>

        <!-- frm de camara - inicio -->
        <div class="container mt-4">
            <div class="row">
                <div class="col-12 col-md-12">
                    <div id="canvas-container" class="position-relative">
                        <video id="video" class="w-100" autoplay></video>
                        <canvas id="overlay" class="position-absolute top-0 left-0 w-100 h-100"></canvas>
                    </div>
                </div>
            </div>
            <p id="result" class="mt-3">Escanea un código QR</p>
            <audio id="beep-sound" src="<?php echo SERVERURL; ?>vistas/recursos/audio/blob.mp3" preload="auto"></audio>
        </div>
        <!-- frm de camara - fin -->

      </div>
    </div>
  </div>
</div>
<!-- Modal para  uso de camara -  fin -->


<?php include_once "./vistas/contenidos/js/cosechador.php"; ?>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>

<script>
    $(document).ready(function () {
        $('#timepicker').mdtimepicker({
            timeFormat: 'hh:mm:ss.000', // format of the time value (data-time attribute)
            format: 'hh:mm tt',    // format of the input value
            readOnly: false,       // determines if input is readonly
            hourPadding: false,
            theme: 'green',
            okLabel: 'OK',
            cancelLabel: 'CANCELAR',
        });
    });
</script>


