<script type="text/javascript">
	// cargar funciones menu para cmabair de color.
	window.onload=function (){
        // obetenr la fecha actual y asiganarle al  imput
        const fechaActual = new Date();
        const anio = fechaActual.getFullYear();
        const mes = String(fechaActual.getMonth() + 1).padStart(2, '0'); // Meses son 0-11
        const dia = String(fechaActual.getDate()).padStart(2, '0');
        const fechaFormateada =anio + "-" + mes + "-" + dia;
        document.getElementById('fecha_actual_sistema').value = fechaFormateada;

        // descargar  los datos del API
        //consumir_API();

        // Obtén la URL actual
        var currentUrl = window.location.pathname;

        // Selecciona todos los enlaces en el footer
        var links = document.querySelectorAll("#footer-bar a");

        // Itera sobre los enlaces y verifica si la URL coincide
        links.forEach(function(link) {
         // Obtén la URL del atributo href del enlace
         var linkUrl = new URL(link.href).pathname;

         // Compara la URL del enlace con la URL actual
         if (currentUrl === linkUrl) {
            // Si coincide, añade la clase 'active-nav'
            link.classList.add("active-nav");
            } else {
                // De lo contrario, elimina la clase 'active-nav'
                link.classList.remove("active-nav");
            }
        });


        // parte de buscar camra y acceder a ella - inicio
		const video = document.getElementById('video');
        const overlay = document.getElementById('overlay');
        const result = document.getElementById('result'); // pra  mostrar  los mensajes
        const canvas = overlay.getContext('2d');
        const beepSound = document.getElementById('beep-sound');
        const cameraSelect = document.getElementById('camera-select');

        let currentStream = null;
        let defaultDeviceId = null;

        // Función para listar las cámaras disponibles
        async function listCameras() {
            try {
                const devices = await navigator.mediaDevices.enumerateDevices();
                const videoDevices = devices.filter(device => device.kind === 'videoinput');

                // Lista de cámaras en el menú desplegable
                videoDevices.forEach(device => {
                    const option = document.createElement('option');
                    option.value = device.deviceId;
                    option.textContent = device.label || `Cámara ${cameraSelect.options.length}`;
                    cameraSelect.appendChild(option);
                });

                if (videoDevices.length > 0) {
                    cameraSelect.disabled = false;
                    defaultDeviceId = videoDevices[0].deviceId; // Establecer la primera cámara como predeterminada
                    setCamera(defaultDeviceId);
                } else {
                    console.error('no se econtro camaras disponibles:', error);
                    Swal.fire({
                      title: 'ocurrio un error',
                      text: 'No se encontraron cámaras disponibles.',
                      type: 'error',
                      confirmButtonText: 'Aceptar'
                    });
                }
            } catch (error) {
                console.error('Error al listar las cámaras:', error);
                Swal.fire({
                  title: 'ocurrio un error',
                  text: 'Error al listar las cámaras.',
                  type: 'error',
                  confirmButtonText: 'Aceptar'
                });
            }
        }

        // Función para configurar la cámara seleccionada
        async function setCamera(deviceId) {
            // Detener el flujo de video actual si existe
            if (currentStream) {
                const tracks = currentStream.getTracks();
                tracks.forEach(track => track.stop());
            }

            try {
                // Solicitar acceso a la cámara con el dispositivo específico
                const stream = await navigator.mediaDevices.getUserMedia({
                    video: { deviceId: { exact: deviceId } }
                });

                // Asignar el flujo de video al elemento <video>
                video.srcObject = stream;
                video.setAttribute('playsinline', true); // Necesario para iOS
                video.play();

                // Iniciar el escaneo del código QR
                scanQRCode();

                // Almacenar el flujo actual para detenerlo más tarde si es necesario
                currentStream = stream;
            } catch (error) {
                // Manejo de errores si no se puede acceder a la cámara
                console.error('Error al acceder a la cámara:', error);
                Swal.fire({
                    title: 'Ocurrió un error',
                    text: 'No se pudo acceder a la cámara. Asegúrate de que los permisos están habilitados o habilite la camara en la parte superior izquierda',
                    type: 'error',
                    confirmButtonText: 'Aceptar'
                });
            }
        }

        // Manejar cambio en el select de cámaras
        cameraSelect.addEventListener('change', (event) => {
            const deviceId = event.target.value;
            if (deviceId) {
                setCamera(deviceId);
            }
        });

        
        // Función para validar el DNI
        function isValidDNI(dni) {
            // Verificar que el DNI tenga exactamente 8 dígitos y que sea numérico
            const dniPattern = /^\d{8}$/;
            return dniPattern.test(dni);
        }

        // Mantén un conjunto para almacenar los códigos QR ya detectados
        let processedCodes = new Set();

        // Cargar códigos QR ya procesados desde localStorage
        //if (localStorage.getItem('processedCodes')) {
            //const storedCodes = JSON.parse(localStorage.getItem('processedCodes'));
            //processedCodes = new Set(storedCodes);
        //}

        // Función para escanear el código QR
        function scanQRCode() {
            const frameCanvas = document.createElement('canvas');
            const frameContext = frameCanvas.getContext('2d');

            let lastDetectedCode = null;

            function processFrame() {
                if (video.readyState === video.HAVE_ENOUGH_DATA) {
                    frameCanvas.width = video.videoWidth;
                    frameCanvas.height = video.videoHeight;
                    frameContext.drawImage(video, 0, 0, frameCanvas.width, frameCanvas.height);
                    const imageData = frameContext.getImageData(0, 0, frameCanvas.width, frameCanvas.height);
                    const code = jsQR(imageData.data, frameCanvas.width, frameCanvas.height, {
                        inversionAttempts: "dontInvert",
                    });

                    canvas.clearRect(0, 0, overlay.width, overlay.height);

                    if (code) {
                        const codeData = code.data;
                        // Validar el código QR detectado
                        if (isValidDNI(codeData)) {
                            result.textContent = 'Código QR detectado: ' + codeData;
                            
                            // Verificar si el código QR ya ha sido procesado
                            if (codeData) { //processedCodes.has(codeData)
                               // result.textContent = 'Este código QR ya ha sido Escaneado ...';
                               // lastDetectedCode = null;
                            //} else {
                                // Agregar el nuevo código QR al conjunto
                                processedCodes.add(codeData);

                                // Guardar códigos QR procesados en localStorage
                                //localStorage.setItem('processedCodes', JSON.stringify(Array.from(processedCodes)));


                                //  enviar el Codigo de Qr para  procesarlo
                                listar_kg_cosechador(codeData);
                                drawQRCodeOutline(code);

                                // Reproducir sonido si el código QR ha cambiado desde la última detección
                                if (lastDetectedCode !== codeData) {
                                    beepSound.play();
                                    lastDetectedCode = codeData;
                                }
                            }
                        } else {
                            result.textContent = 'Código QR detectado no es un DNI válido';
                            lastDetectedCode = null; // Resetear cuando el código QR no es válido
                        }
                    } else {
                        result.textContent = 'Escanea un código QR';
                        lastDetectedCode = null; // Resetear cuando no hay código QR detectado
                    }
                }
                requestAnimationFrame(processFrame);
            }

            function drawQRCodeOutline(code) {
                const points = code.location.topLeftCorner;
                canvas.strokeStyle = 'green';
                canvas.lineWidth = 4;

                canvas.beginPath();
                canvas.moveTo(points.x, points.y);
                canvas.lineTo(code.location.topRightCorner.x, code.location.topRightCorner.y);
                canvas.lineTo(code.location.bottomRightCorner.x, code.location.bottomRightCorner.y);
                canvas.lineTo(code.location.bottomLeftCorner.x, code.location.bottomLeftCorner.y);
                canvas.closePath();
                canvas.stroke();
            }

            processFrame();
        }

         // Inicializar
        listCameras();
   }

   	// funcion para listar planta
	function listar_kg_cosechador(dni){
        // Ejemplo de uso
        const fecha = document.getElementById("fecha_actual_sistema").value;
        const cosechador = dni;

        // esto  para obetenr informacion de una BD.
        /*
		if(cosechador_dni != ""){
	  		let datos = new FormData();
	  		datos.append("cosechador_dni_list",cosechador_dni);
            datos.append("cosechador_fecha_list",cosecha_fecha);

	  		fetch("<?php  echo SERVERURL; ?>ajax/cosechadorAjax.php", {
	  			method: 'POST',
	  			body: datos
	  		})
	  		.then(respuesta => respuesta.json())
	  		.then(respuesta => {

	  			//  hacemos uan validacion  para mostra  las alertas  o  mostrar dato.
	  			if(respuesta.Tipo == "error"){
	  				return alertas_ajax(respuesta); 
	  			}else{
	  				document.getElementById("frm_header_cosecha").innerHTML = ""; 
					document.getElementById("list_kg_frm").innerHTML = ""; 
					document.getElementById("frm_footer_cosecha").innerHTML = ""; 

					// declaramos dos cvariables
					let total_kg = 0;
					let contador = 0;

					$("#frm_header_cosecha").append('<div class="col-12">'+
	                                '<h4>Trab: '+respuesta[0].general_dato_cosechador+'</h4>'+
	                                '<h4>Lote: '+respuesta[0].general_lote+'</h4>'+
	                            '</div>');

					respuesta.forEach(function(dato) {
						total_kg += parseFloat(dato.total_kg_exportable);
						contador += parseInt(dato.total_registro);
					    $("#list_kg_frm").append('<tr>'+
	                            '<td class="color-black-dark">'+dato.general_hora+'</td>'+
	                            '<td class="color-blue-dark">'+dato.general_variedad+'</td>'+
								'<td class="color-red-dark">'+dato.general_turno+'</td>'+
	                            '<td>'+
	                            	'<i class="color-green-dark">'+parseFloat(dato.total_kg_exportable)+' kg</i>'+
	                            '</td>'+
	                        '</tr');
					});

					$("#frm_footer_cosecha").append('<div class="col-5">'+
	                                '<p class="text-start color-white mb-0 pb-1"><i class="fa fa-calendar-alt color-white me-2"></i> '+respuesta[0].general_fecha+'</p>'+
	                            '</div>'+
	                            '<div class="col-4">'+
	                                '<p class="text-center color-white mb-0 pb-1"><i class="fa fa-weight me-2 color-white"></i> '+parseFloat(total_kg.toFixed(3))+' KG</p>'+
	                            '</div>'+
	                            '<div class="col-3">'+
	                                '<p class="text-end color-white mb-0 pb-1"><i class="fa fa-tasks me-2 color-white"></i> '+contador+'</p>'+
	                            '</div>');

					$('#exampleModal').modal('hide');
	  			}
					
			});
	  	}else{
		  	Swal.fire({
			  title: 'ocurrio un error',
			  text: 'seleccionar bien Datos',
			  type: 'error',
			  confirmButtonText: 'Aceptar'
		    });
	  	} */

        if(cosechador != ""){
            // Recuperar los datos de la caché
            const datosCache = localStorage.getItem('datos');
            const datos = JSON.parse(datosCache);

            // Función para filtrar los datos por fecha y cosechador
            function filtrarDatos(fecha, cosechador) {
                // Verificar si datos es undefined o no tiene data
                if (!datos || !datos.data || datos.data.length === 0) {
                    Swal.fire({
                      title: 'ocurrio un error',
                      text: 'No hay datos disponibles o la local store está vacía, por favor sincronizar los datos',
                      type: 'warning',
                      confirmButtonText: 'Aceptar'
                    });
                }

                const resultados = datos.data.filter((dato) => {
                    return dato.fecha === fecha && dato.cosechador === cosechador;
                });

                // Verificar si no se encontraron resultados
                if (resultados.length === 0) {
                    Swal.fire({
                      title: 'ocurrio un error',
                      text: 'No se encontraron datos para la fecha y cosechador proporcionados, por favor sincronizar os datos',
                      type: 'warning',
                      confirmButtonText: 'Aceptar'
                    });
                }

                return resultados
            }

            try {
                const datosFiltrados = filtrarDatos(fecha, cosechador);

                document.getElementById("frm_header_cosecha").innerHTML = ""; 
                document.getElementById("list_kg_frm").innerHTML = ""; 
                document.getElementById("frm_footer_cosecha").innerHTML = ""; 

                // declaramos dos cvariables
                let total_kg = 0;
                let contador = 0;
                let total_descarte = 0;

                $("#frm_header_cosecha").append('<div class="col-12">'+
                                '<h4>Trab. '+datosFiltrados[0].cosechador_nombre+'</h4>'+
                                '<h4>Lote: '+datosFiltrados[0].lote+'</h4>'+
                            '</div>');

                datosFiltrados.forEach(function(dato) {
                    total_kg += parseFloat(dato.exportable);
                    total_descarte += parseFloat(dato.nacional);
                    contador = contador +1;
                    $("#list_kg_frm").append('<tr>'+
                            '<td class="color-black-dark">'+dato.hora+'</td>'+
                            '<td class="color-blue-dark">'+dato.variedad+'</td>'+
                            '<td class="color-red-dark">'+dato.turno+'</td>'+
                            '<td>'+
                                '<i class="color-green-dark">'+parseFloat(dato.exportable)+' kg</i>'+
                            '</td>'+
                            '<td>'+
                                '<i class="color-red-dark">'+parseFloat(dato.nacional)+' kg</i>'+
                            '</td>'+
                        '</tr');
                });

                $("#frm_footer_cosecha").append('<div class="col-4">'+
                                '<p class="text-start color-white mb-0 pb-1"><i class="fa fa-calendar-alt color-white me-2"></i> '+datosFiltrados[0].fecha+'</p>'+
                            '</div>'+
                            '<div class="col-4">'+
                                '<p class="text-center color-white mb-0 pb-1"><i class="fa fa-weight color-white"></i> '+parseFloat(total_kg.toFixed(3))+' KG</p>'+
                            '</div>'+
                            '<div class="col-4">'+
                                '<p class="text-end color-white mb-0 pb-1"><i class="fa fa-weight color-white"></i> '+parseFloat(total_descarte.toFixed(3))+' KG</p>'+
                            '</div>');

                $('#exampleModal').modal('hide');
                
            } catch (error) {
                Swal.fire({
                  title: 'Trabajador no encontrado, busque en  otras fechas',
                  text: 'Ocurrio un error al filtrar los datos, ' + error.message,
                  type: 'warning',
                  confirmButtonText: 'Aceptar'
                });
            }
        }else{
            Swal.fire({
              title: 'ocurrio un error',
              text: 'seleccionar bien Datos',
              type: 'error',
              confirmButtonText: 'Aceptar'
            });
        }
	}

    //  funcion para consumir API de agro +
    function consumir_API(){
        var  fecha_actual =  document.getElementById("fecha_actual_sistema").value;
        var API_ID = 1;
        if(API_ID != ""){
            let datos = new FormData();
            datos.append("api_id",API_ID);
            datos.append("api_fecha",fecha_actual);

            fetch("<?php  echo SERVERURL; ?>ajax/cosechadorAjax.php", {
                method: 'POST',
                body: datos
            })
            .then(respuesta => respuesta.json())
            .then(respuesta => {
                // Verificar si hay datos en la respuesta
                if (respuesta.data && respuesta.data.length > 0) {
                    // Guardar los datos en el LOCAL STORAGE
                    localStorage.setItem('datos', JSON.stringify(respuesta));

                    // Mostrar mensaje de éxito
                    Swal.fire({
                      title: 'Datos sincronizados',
                      text: 'Datos sincronizados correctamente.',
                      type: 'success',
                      confirmButtonText: 'Aceptar'
                    });
                } else {
                    Swal.fire({
                      title: 'ocurrio un error',
                      text: 'No se encontraron datos en la respuesta al consumir el API.',
                      type: 'error',
                      confirmButtonText: 'Aceptar'
                    });
                }

                //var DatosJson =  JSON.parse(JSON.stringify(respuesta));

                
                
                /*
                for (let i = 0; i < DatosJson.data.length; i++) {
                  console.log(DatosJson.data[i].cosechador_nombre);
                }
                */
            
                    
            });
        }else{
            Swal.fire({
              title: 'ocurrio un error',
              text: 'seleccionar bien Datos',
              type: 'error',
              confirmButtonText: 'Aceptar'
            });
        }
    }



</script>