
<style type="text/css">
  /* Global Styles */

* {
  box-sizing: border-box;
  margin: 0;
  padding: 0;
  font-family: Arial, sans-serif;
}

.container {
  display: flex;
  flex-direction: column;
  align-items: center;
  padding: 20px;
  background-color: #f0f0f0;
}

.row {
  display: flex;
  flex-wrap: wrap;
  justify-content: center;
}

.col-lg-6, .col-md-6, .col-sm-12, .col-xs-12 {
  flex-basis: 50%;
  padding: 10px;
}

.panel {
  display: flex;
  flex-direction: column;
  align-items: center;
  padding: 20px;
  background-color: #fff;
  border-radius: 10px;
  box-shadow: 0 0 10px rgba(0, 0, 0, 0.1);
}

.left-panel {
  background-color: #f7f7f7;
  border-radius: 10px 0 0 10px;
}

.forms-container {
  display: flex;
  flex-direction: column;
  align-items: center;
  padding: 20px;
  background-color: #fff;
  border-radius: 10px;
  box-shadow: 0 0 10px rgba(0, 0, 0, 0.1);
}

.signin-signup {
  display: flex;
  flex-direction: column;
  align-items: center;
  padding: 20px;
}

.title {
  font-size: 24px;
  font-weight: bold;
  margin-bottom: 20px;
}

.input-field {
  margin-bottom: 20px;
  padding: 10px;
  border: 1px solid #ccc;
  border-radius: 10px;
}

.input-field input {
  width: 100%;
  padding: 10px;
  border: none;
  border-radius: 10px;
}

.btn {
  padding: 10px 20px;
  border: none;
  border-radius: 10px;
  font-size: 16px;
  font-weight: bold;
  cursor: pointer;
}

.btn.solid {
  background-color: #4CAF50;
  color: #fff;
}

.image {
  width: 50%;
  height: 50%;
  object-fit: cover;
  border-radius: 10px;
}

/* Responsive Styles */

@media (max-width: 768px) {
  .row {
    flex-direction: column;
  }
  .col-lg-6, .col-md-6, .col-sm-12, .col-xs-12 {
    flex-basis: 100%;
  }
  .panel {
    width: 100%;
  }
  .forms-container {
    width: 100%;
  }
}

@media (max-width: 480px) {
  .container {
    padding: 10px;
  }
  .row {
    padding: 10px;
</style>

<div class="container">
  <div class="row">
    <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
      <div class="panel left-panel">
        <div class="content">
          <h4>PROCESOS AGROINDUSTRIALES S.A. (PROAGRO)</h4>
        </div>
        <img src="<?php echo SERVERURL; ?>vistas/recursos/icons/log.svg" class="image" alt="" />
      </div>
    </div>
    <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
      <div class="forms-container">
        <div class="signin-signup">
          <form action="#" class="sign-in-form">
            <h2 class="title">Iniciar Sesión</h2>
            <div class="input-field">
              <input type="text" placeholder="USUARIO" id="login_dni_ini" name="login_dni_ini" />
            </div>
            <div class="input-field">
              <input type="password" placeholder="Password" id="login_clave_ini" name="login_clave_ini" />
            </div>
            <input type="button" value="INGRESAR" class="btn solid" onclick="iniciar_sesion();" />
          </form>
        </div>
      </div>
    </div>
  </div>
</div>




<?php include_once "./vistas/contenidos/js/login.php"; ?>